#
# 405_linux_2.0_glibc2.1.mk - make variables and rules specific to Linux 2.x
#                             and glibc-2.1, targeting the ppc 405 from i586
#

Linux = 1
PowerPCProcessor = 1
EmbeddedSystem = 1

ABSTOP = $(shell cd $(TOP); pwd)

#
# Python set-up
#
# You must set a path to a Python 1.5.2 interpreter. If you do not
# wish to make a complete installation, you may download a minimal
# Python from ftp://ftp.uk.research.att.com/pub/omniORB/python/
# In that case, uncomment the first line below.

#PYTHON = $(ABSTOP)/$(BINDIR)/omnipython
#PYTHON = /usr/local/bin/python
PYTHON = /usr/bin/python

#
# Include general unix things
#

include $(THIS_IMPORT_TREE)/mk/unix.mk


#
# Standard programs
#

CROSS_TOOLDIR = /opt/hardhat/devkit/ppc/405/bin
# First is for hardhat's 2.95 compiler, next is for gcc3.0 compiled with
# hardhat's 2.95
#CROSS_TOOL_PREFIX = ppc_405-
CROSS_TOOL_PREFIX = powerpc-linux-

AR = ar cq

CPP = $(CROSS_TOOLDIR)/$(CROSS_TOOL_PREFIX)cpp

#############################################################################
# To use g++ uncomment the following lines:                                 #
#############################################################################
CXX = $(CROSS_TOOLDIR)/$(CROSS_TOOL_PREFIX)g++
CXXMAKEDEPEND += -D__cplusplus -D__GNUG__ -D__GNUC__
CXXDEBUGFLAGS = -O2

CXXLINK		= $(CXX)
CXXLINKOPTIONS  = $(CXXDEBUGFLAGS) $(CXXOPTIONS) \
		$(patsubst %,-Wl$(comma)-rpath$(comma)%,$(IMPORT_LIBRARY_DIRS))

CXXOPTIONS      = -Wall -Wno-unused $(CROSS_CFLAGS)
EgcsMajorVersion = 1
EgcsMinorVersion = 1

#############################################################################
# To use KAI C++ uncomment the following lines:                             #
#############################################################################
#KCC = 1
#AR = KCC --thread_safe -o
#CXX = /usr/local/KAI/KCC.pu-4.0b-1/KCC_BASE/bin/KCC
#CXXMAKEDEPEND += -D__cplusplus -D__GNUG__ -D__GNUC__
#CXXDEBUGFLAGS = +K0 --one_per --thread_safe --exceptions
#
#CXXLINK		= $(CXX)
#CXXLINKOPTIONS  = $(CXXDEBUGFLAGS) $(CXXOPTIONS) --thread_safe
#CXXOPTIONS      =

#############################################################################
CC           = $(CROSS_TOOLDIR)/$(CROSS_TOOL_PREFIX)gcc
CMAKEDEPEND  += -D__GNUC__
CDEBUGFLAGS  = -O

CLINK        = $(CC)
CLINKOPTIONS = $(CDEBUGFLAGS) $(COPTIONS) \
	       $(patsubst %,-Wl$(comma)-rpath$(comma)%,$(IMPORT_LIBRARY_DIRS))

# FIXME check this
COPTIONS      += $(CROSS_CFLAGS)
INSTALL = install -c

IMPORT_CPPFLAGS += -D__ppc__ -D__linux__ -D__OSVERSION__=2


#
# CORBA stuff
#

omniORBGatekeeperImplementation = OMNIORB_TCPWRAPGK
CorbaImplementation = OMNIORB

#
# OMNI thread stuff
#

ThreadSystem = Posix
OMNITHREAD_POSIX_CPPFLAGS = -DNoNanoSleep
OMNITHREAD_CPPFLAGS = -D_REENTRANT
OMNITHREAD_LIB = $(patsubst %,$(LibSearchPattern),omnithread)

ifndef UseMITthreads
OMNITHREAD_POSIX_CPPFLAGS += -DPthreadDraftVersion=10
OMNITHREAD_LIB += -lpthread
else
OMNITHREAD_POSIX_CPPFLAGS += -DPthreadDraftVersion=8
OMNITHREAD_CPPFLAGS += -D_MIT_POSIX_THREADS
OMNITHREAD_LIB += -lpthreads
endif

lib_depend := $(patsubst %,$(LibPattern),omnithread)
OMNITHREAD_LIB_DEPEND := $(GENERATE_LIB_DEPEND)


# Default location of the omniORB configuration file [falls back to this if
# the environment variable OMNIORB_CONFIG is not set] :

OMNIORB_CONFIG_DEFAULT_LOCATION = /etc/omniORB.cfg

# Default directory for the omniNames log files.
OMNINAMES_LOG_DEFAULT_LOCATION = /var/omninames

#
# Shared Library support.
#
BuildSharedLibrary = 1       # Enable
SHAREDLIB_CPPFLAGS = -fPIC   # compiler flag

ifeq ($(notdir $(CC)),KCC)
SharedLibraryPlatformLinkFlagsTemplate = --thread_safe --soname $$soname
endif

#
# Extra things needed for hosting the cross compile, mostly from rtems
# FIXME stick this stuff somewhere more appropriate
# FIXME need some way to pass in the -mcpu=403

# The HOSTBINDIR variable is used to locate the HOST IDL compiler.
BASE_OMNI_TREE = /opt/omniorb3/native
HOSTBINDIR = bin/i586_linux_2.0_glibc2.1
BINDIR     = $(HOSTBINDIR)

HOST_IDL_FLAGS = -h .hh -s SK.cc
OMNIORB_IDL_ONLY = $(BASE_OMNI_TREE)/$(BINDIR)/omniidl -bcxx
OMNIORB_IDL_ANY_FLAGS = -Wba
OMNIORB_IDL = $(OMNIORB_IDL_ONLY) $(OMNIORB_IDL_ANY_FLAGS)
OMNIORB_IDL_OUTPUTDIR_PATTERN = -C%
OMNIORB_IDL_LC_FLAGS = -l

OMKDEPEND = $(BASE_OMNI_TREE)/$(HOSTBINDIR)/omkdepend
CXXMAKEDEPEND   = $(OMKDEPEND) -D__cplusplus -D__GNUG__ -D__GNUC__
CMAKEDEPEND     = $(OMKDEPEND) -D__GNUC__

#
# everything else is default from unix.mk

